perf: let's disable symlinks when they are not available
[git/git-svn.git] / t / perf / perf-lib.sh
blob9fa07066d14a4328d654f58fc5bdae4bb31bd214
1 # Performance testing framework. Each perf script starts much like
2 # a normal test script, except it sources this library instead of
3 # test-lib.sh. See t/perf/README for documentation.
5 # Copyright (c) 2011 Thomas Rast
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 2 of the License, or
10 # (at your option) any later version.
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
17 # You should have received a copy of the GNU General Public License
18 # along with this program. If not, see http://www.gnu.org/licenses/ .
20 # do the --tee work early; it otherwise confuses our careful
21 # GIT_BUILD_DIR mangling
22 case "$GIT_TEST_TEE_STARTED, $* " in
23 done,*)
24 # do not redirect again
26 *' --tee '*|*' --va'*)
27 mkdir -p test-results
28 BASE=test-results/$(basename "$0" .sh)
29 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
30 echo $? > $BASE.exit) | tee $BASE.out
31 test "$(cat $BASE.exit)" = 0
32 exit
34 esac
36 TEST_DIRECTORY=$(pwd)/..
37 TEST_OUTPUT_DIRECTORY=$(pwd)
38 if test -z "$GIT_TEST_INSTALLED"; then
39 perf_results_prefix=
40 else
41 perf_results_prefix=$(printf "%s" "${GIT_TEST_INSTALLED%/bin-wrappers}" | tr -c "[a-zA-Z0-9]" "[_*]")"."
42 # make the tested dir absolute
43 GIT_TEST_INSTALLED=$(cd "$GIT_TEST_INSTALLED" && pwd)
46 TEST_NO_CREATE_REPO=t
47 TEST_NO_MALLOC_CHECK=t
49 . ../test-lib.sh
51 # Variables from test-lib that are normally internal to the tests; we
52 # need to export them for test_perf subshells
53 export TEST_DIRECTORY TRASH_DIRECTORY GIT_BUILD_DIR GIT_TEST_CMP
55 perf_results_dir=$TEST_OUTPUT_DIRECTORY/test-results
56 mkdir -p "$perf_results_dir"
57 rm -f "$perf_results_dir"/$(basename "$0" .sh).subtests
59 if test -z "$GIT_PERF_REPEAT_COUNT"; then
60 GIT_PERF_REPEAT_COUNT=3
62 die_if_build_dir_not_repo () {
63 if ! ( cd "$TEST_DIRECTORY/.." &&
64 git rev-parse --build-dir >/dev/null 2>&1 ); then
65 error "No $1 defined, and your build directory is not a repo"
69 if test -z "$GIT_PERF_REPO"; then
70 die_if_build_dir_not_repo '$GIT_PERF_REPO'
71 GIT_PERF_REPO=$TEST_DIRECTORY/..
73 if test -z "$GIT_PERF_LARGE_REPO"; then
74 die_if_build_dir_not_repo '$GIT_PERF_LARGE_REPO'
75 GIT_PERF_LARGE_REPO=$TEST_DIRECTORY/..
78 test_perf_create_repo_from () {
79 test "$#" = 2 ||
80 error "bug in the test script: not 2 parameters to test-create-repo"
81 repo="$1"
82 source="$2"
83 source_git=$source/$(cd "$source" && git rev-parse --git-dir)
84 mkdir -p "$repo/.git"
86 cd "$repo/.git" &&
87 { cp -Rl "$source_git/objects" . 2>/dev/null ||
88 cp -R "$source_git/objects" .; } &&
89 for stuff in "$source_git"/*; do
90 case "$stuff" in
91 */objects|*/hooks|*/config)
94 cp -R "$stuff" . || exit 1
96 esac
97 done &&
98 cd .. &&
99 git init -q && {
100 test_have_prereq SYMLINKS ||
101 git config core.symlinks false
102 } &&
103 mv .git/hooks .git/hooks-disabled 2>/dev/null
104 ) || error "failed to copy repository '$source' to '$repo'"
107 # call at least one of these to establish an appropriately-sized repository
108 test_perf_default_repo () {
109 test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_REPO"
111 test_perf_large_repo () {
112 if test "$GIT_PERF_LARGE_REPO" = "$GIT_BUILD_DIR"; then
113 echo "warning: \$GIT_PERF_LARGE_REPO is \$GIT_BUILD_DIR." >&2
114 echo "warning: This will work, but may not be a sufficiently large repo" >&2
115 echo "warning: for representative measurements." >&2
117 test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_LARGE_REPO"
119 test_checkout_worktree () {
120 git checkout-index -u -a ||
121 error "git checkout-index failed"
124 # Performance tests should never fail. If they do, stop immediately
125 immediate=t
127 test_run_perf_ () {
128 test_cleanup=:
129 test_export_="test_cleanup"
130 export test_cleanup test_export_
131 /usr/bin/time -f "%E %U %S" -o test_time.$i "$SHELL" -c '
132 . '"$TEST_DIRECTORY"/test-lib-functions.sh'
133 test_export () {
134 [ $# != 0 ] || return 0
135 test_export_="$test_export_\\|$1"
136 shift
137 test_export "$@"
139 '"$1"'
140 ret=$?
141 set | sed -n "s'"/'/'\\\\''/g"';s/^\\($test_export_\\)/export '"'&'"'/p" >test_vars
142 exit $ret' >&3 2>&4
143 eval_ret=$?
145 if test $eval_ret = 0 || test -n "$expecting_failure"
146 then
147 test_eval_ "$test_cleanup"
148 . ./test_vars || error "failed to load updated environment"
150 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
151 echo ""
153 return "$eval_ret"
157 test_perf () {
158 test_start_
159 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
160 test "$#" = 2 ||
161 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
162 export test_prereq
163 if ! test_skip "$@"
164 then
165 base=$(basename "$0" .sh)
166 echo "$test_count" >>"$perf_results_dir"/$base.subtests
167 echo "$1" >"$perf_results_dir"/$base.$test_count.descr
168 if test -z "$verbose"; then
169 printf "%s" "perf $test_count - $1:"
170 else
171 echo "perf $test_count - $1:"
173 for i in $(test_seq 1 $GIT_PERF_REPEAT_COUNT); do
174 say >&3 "running: $2"
175 if test_run_perf_ "$2"
176 then
177 if test -z "$verbose"; then
178 printf " %s" "$i"
179 else
180 echo "* timing run $i/$GIT_PERF_REPEAT_COUNT:"
182 else
183 test -z "$verbose" && echo
184 test_failure_ "$@"
185 break
187 done
188 if test -z "$verbose"; then
189 echo " ok"
190 else
191 test_ok_ "$1"
193 base="$perf_results_dir"/"$perf_results_prefix$(basename "$0" .sh)"."$test_count"
194 "$TEST_DIRECTORY"/perf/min_time.perl test_time.* >"$base".times
196 test_finish_
199 # We extend test_done to print timings at the end (./run disables this
200 # and does it after running everything)
201 test_at_end_hook_ () {
202 if test -z "$GIT_PERF_AGGREGATING_LATER"; then
203 ( cd "$TEST_DIRECTORY"/perf && ./aggregate.perl $(basename "$0") )
207 test_export () {
208 export "$@"